#include <gint/display.h>
#include <gint/keyboard.h>
#include <string.h>

#include "fsctl/menu.h"

//---
// Public
//---

int main(void)
{
    int key;
    int tab;

    rom_menu_init();
    info_menu_init();
    fat_menu_init();
    list_menu_init();
    test_menu_init();

    tab = 0;
    while (1)
    {
        dclear(C_WHITE);
        if (tab == 0) { rom_menu_display();  }
        if (tab == 1) { info_menu_display(); }
        if (tab == 2) { fat_menu_display();  }
        if (tab == 3) { list_menu_display(); }
        if (tab == 4) { test_menu_display(); }
        dupdate();

        switch (key = getkey().key)
        {
            case KEY_F1:
                tab = 0;
                break;
            case KEY_F2:
                tab = 1;
                break;
            case KEY_F3:
                tab = 2;
                break;
            case KEY_F4:
                tab = 3;
                break;
            case KEY_F5:
                tab = 4;
                break;
            default:
                if (tab == 0) { rom_menu_keyboard(key);  }
                if (tab == 1) { info_menu_keyboard(key); }
                if (tab == 2) { fat_menu_keyboard(key);  }
                if (tab == 3) { list_menu_keyboard(key); }
                if (tab == 4) { test_menu_keyboard(key); }
        }
    }

    return 1;
}
