#include "fsctl/menu.h"
#include "fsctl/fugue.h"
#include "fsctl/utils/fs_table.h"
#include "fsctl/utils/display.h"

//---
// Public
//---

/* list_menu_init() : init menu */
void list_menu_init(void)
{
    ;
}

/* fat1_menu_display() : display menu */
void list_menu_display(void)
{
    fugue_dirent_t dir;
    fugue_file_t file;
    int y;

    fs_table_dtitle();
    if (fugue_fs_opendir(&dir) != 0)
        return;

    y = 0;
    while (fugue_fs_readdir(&dir, &file) == 0)
    {
        _printXY(0, ++y, "(%d) %s", file.size, file.name);
    }
    fugue_fs_closedir(&dir);
}

/* list_menu_keyboard() : handle keyboard */
void list_menu_keyboard(int key)
{
    switch(key)
    {
        case KEY_LEFT:
            fs_table_select_left();
            break;
        case KEY_RIGHT:
            fs_table_select_right();
            break;
    }
}
